% 
% function RX()
% 
%   This function runs the RX anomaly-detection algorithm.
%

%
% CPPCA-PR: CPPCA with Partitioned-Residual Reconstruction
% Copyright (C) 2012  James E. Fowler
% http://www.ece.mstate.edu/~fowler
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function D = RX(X)

[N M] = size(X);

X_mean = mean(X.').';

X = X - repmat(X_mean, [1 M]);

Sigma = (X * X')/M;

Sigma_inv = inv(Sigma);
for m = 1:M
 D(m) = X(:, m)' * Sigma_inv * X(:, m);
end
