% 
% function RX_threshold()
% 
%   This function thresholds an RX-detection map.
%

%
% CPPCA-PR: CPPCA with Partitioned-Residual Reconstruction
% Copyright (C) 2012  James E. Fowler
% http://www.ece.mstate.edu/~fowler
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function tau = RX_threshold(D, gamma)

if ((gamma <= 0) || (gamma >= 1.0))
  disp('gamma must be between 0.0 and 1.0');
  return;
end

d = sort(D, 'ascend');
tau = d(floor(length(D) * gamma));
