% 
% function SNR_PartitionedDataset()
% 
%   This function calculates the SNR for a partitioned dataset.
%

%
% CPPCA-PR: CPPCA with Partitioned-Residual Reconstruction
% Copyright (C) 2012  James E. Fowler
% http://www.ece.mstate.edu/~fowler
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function D = SNR_PartitionedDataset(X, X_check, map, Psi)

J = length(X);

m2 = 1;
for j = 1:J
  Xj = X{j}(:, map{j});
  X_checkj = X_check{j}(:, map{j});

  [N Mj] = size(Xj);
  for m = 1:Mj
    s(m2) = SNR(Xj(:, m), Psi * X_checkj(:, m));
    m2 = m2 + 1;
  end
end

D = mean(s);
